namespace Turbo.Plugins.LightningMod
{
    public class DemonHunterEvasiveFirePlugin : AbstractSkillHandler, ISkillHandler
	{
        public DemonHunterEvasiveFirePlugin()
            : base(CastType.BuffSkill, CastPhase.AutoCast, CastPhase.Move, CastPhase.Attack)
        {
            Enabled = false;
        }

        public override void Load(IController hud)
        {
            base.Load(hud);
            AssignedSnoPower = Hud.Sno.SnoPowers.DemonHunter_EvasiveFire;

            CreateCastRule()
                .IfInTown().ThenNoCastElseContinue()
                .IfCastingIdentify().ThenNoCastElseContinue()
                .IfCastingPortal().ThenNoCastElseContinue() 
                .IfOnCooldown().ThenNoCastElseContinue()
                .IfCanCastBuff().ThenContinueElseNoCast() 
                .IfCanCastSimple().ThenContinueElseNoCast()
                .IfEnoughMonstersNearby(ctx => 50, ctx => 1).ThenContinueElseNoCast()
				.IfSpecificBuffIsAboutToExpire(hud.Sno.SnoPowers.WrapsOfClarity, 1, 30, 100).ThenCastElseContinue()
				.IfPrimaryResourceAmountIsBelow(ctx => 30).ThenCastElseContinue()
				.IfEnoughMonstersNearbyCursor(ctx => 30, ctx => 1).ThenContinueElseNoCast()
				.IfSpecificBuffIsAboutToExpire(hud.Sno.SnoPowers.Generic_ItemPassiveUniqueRing735x1, 1, 30, 100).ThenCastElseContinue();
        }
    }
}