namespace Turbo.Plugins.LightningMod
{
    public class DemonHunterShadowPowerPlugin : AbstractSkillHandler, ISkillHandler
    {
        public DemonHunterShadowPowerPlugin()
            : base(CastType.BuffSkill, CastPhase.AutoCast, CastPhase.PreAttack)
        {
            Enabled = false;
        }

        public override void Load(IController hud)
        {
            base.Load(hud);
            AssignedSnoPower = Hud.Sno.SnoPowers.DemonHunter_ShadowPower;

            CreateCastRule()
                .IfInTown().ThenNoCastElseContinue()
                .IfCastingIdentify().ThenNoCastElseContinue()
                .IfCastingPortal().ThenNoCastElseContinue()
                .IfOnCooldown().ThenNoCastElseContinue()
                .IfCanCastBuff().ThenContinueElseNoCast() 
                .IfCanCastSimple().ThenContinueElseNoCast()
				.IfTrue(IsPotionOnCoolDown).ThenCastElseContinue()
				.IfEnoughMonstersNearby(ctx => 40, ctx => 1).ThenContinueElseNoCast()
				.IfSpecificBuffIsAboutToExpire(hud.Sno.SnoPowers.ElusiveRing, 1, 30, 100).ThenCastElseContinue();					
        }
		
		private bool IsPotionOnCoolDown(TestContext ctx)
        {
			bool IsOnCooldown;
			double Cooldown;
			Cooldown = (Hud.Game.Me.Powers.HealthPotionSkill.CooldownFinishTick - Hud.Game.CurrentGameTick) / 60d;
			IsOnCooldown = Cooldown < 30 && Cooldown > 29.6 ? true : false;
			return IsOnCooldown;
        }
    }
}